@rem  THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
@rem  5724-I04 (C) COPYRIGHT International Business Machines Corp., 2005, 2006
@rem  All Rights Reserved * Licensed Materials - Property of IBM
@rem  US Government Users Restricted Rights - Use, duplication or disclosure
@rem  restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off
REM Usage: ifix_IC52868.bat -install
setlocal

echo  Ifix IC52868: 
echo  THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
echo  5724-I04 (C) COPYRIGHT International Business Machines Corp., 2005, 2006
echo  All Rights Reserved * Licensed Materials - Property of IBM
echo  US Government Users Restricted Rights - Use, duplication or disclosure
echo  restricted by GSA ADP Schedule Contract with IBM Corp.
echo.
echo    Please allow the ifix installation to run to completion. i.e. do not control-c 
echo.
echo    Please review the readme_IC52868.txt file delivered with this ifix
echo    before proceeding...
echo.
echo.
pause


@rem Check parameters  
IF [%1] ==[] GOTO Syntax 


@rem Try to setup the WAS command line environment by using the default WAS install location

if EXIST "C:\Program Files\WebSphere\AppServer\bin\setupCmdLine.bat" goto setupwas
   GOTO checkenv
   
:setupwas
call "c:\Program Files\WebSphere\AppServer\bin\setupCmdLine.bat"

:checkenv         
@rem Check required Environment Variables are setup                      
IF  "%WAS_HOME%".== "". goto washome

IF  "%WVS_ROOT%".== "". goto wvsroot 

GOTO:parms

:Syntax
 @echo.
 @echo Ifix_IC52868: WVS Ifix IC52868 Installer  
 @echo  to install ifix  syntax: ifix_IC52868.bat -install 
 @echo  to uninstall ifix  syntax: ifix_IC52868.bat -uninstall 
 @echo  off
 GOTO:EOF

:washome
  @echo.
  @echo Ifix_IC52868: Please run WebSphere Application Servers setupCmdLine.bat to setup
  @echo          the WAS Command line environment
  @echo Ifix_IC52868: The WebSphere Application Servers setupCmdLine.bat is located in WAS_HOME/bin directory.
  @echo.
  pause
  GOTO:EOF
  
:wvsroot
  @echo.
  @echo Ifix_IC52868: Please configure WebSphere Voice Server wvs.setenv according
  @echo          to the WVS InfoCenter 
  @echo.
  pause
  GOTO:EOF

:parms
set installoption=false
set uninstalloption=false

:loop
if '%1'=='-install' goto installoption
if '%1'=='-uninstall' goto uninstalloption
if '%1'=='' goto syntax
goto syntax

:installoption
set installoption=true
GOTO:GO

:uninstalloption
set uninstalloption=true
GOTO:GO


:GO    

pushd  

if  "%installoption%" == "true" goto installparm

if  "%uninstalloption%" == "true" goto uninstallparm

:installparm 
  if NOT EXIST "%WVS_ROOT%\ifix\IC52868\wvsapp.ear.bak" goto installedfpcheck
    echo "Ifix_IC52868: Ifix IC52868 is applied, please uninstall before trying to reinstall ifix"
    goto:EOF

:installedfpcheck
  if EXIST "%WVS_ROOT%\fixes\5.1.3.3" goto installifix
    echo "Ifix_IC52868: Ifix IC52868 requires that FP3 is applied, please install FP3 before trying to reinstall ifix"
    goto:EOF
    
    
:installifix  

 @rem # Check that the ifix files are found

 @echo Ifix_IC52868: Checking for ifix files ...
 @echo Ifix_IC52868: Checking for ifix files ...  >> "%WVS_ROOT%\log\IC52868.log"
  if NOT EXIST "%~dp0wvsapp.ear" goto missing
      @echo Ifix_IC52868: Ifix files found.. proceeding to install ifix
      @echo Ifix_IC52868: Ifix files found.. proceeding to install ifix >> "%WVS_ROOT%\log\IC52868.log"
      @mkdir "%WVS_ROOT%\ifix\IC52868"
      
      echo Ifix_IC52868: Stopping WebSphere Application Server
      echo Ifix_IC52868: Stopping WebSphere Application Server >> "%WVS_ROOT%\log\IC52868.log"
      call "%WAS_HOME%\bin\stopServer.bat" server1 -quiet >> "%WVS_ROOT%\log\IC52868.log"
      if ERRORLEVEL -10  ( 
         echo Ifix_IC52868: WebSphere Application Server Successfully stopped. 
         echo Ifix_IC52868: WebSphere Application Server Successfully stopped.  >> "%WVS_ROOT%\log\IC52868.log"
      ) else (
         echo.
         echo Ifix_IC52868: WebSphere Application Server Failed to stop Successfully. Exiting ifix installation.   
         echo Ifix_IC52868: WebSphere Application Server Failed to stop Successfully.  Exiting ifix installation. >> "%WVS_ROOT%\log\IC52868.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"
         goto:EOF
      )
      timeout /T 20 /NOBREAK  >>  "%WVS_ROOT%\log\IC52868.log"
	  
      @rem Backup SIV config files ----------------------------------------------------
      echo Ifix_IC52868: Backing up SIV config files... >> "%WVS_ROOT%\log\IC52868.log"
      mkdir "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF\ibm-web-bnd.xmi" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF\web.xml" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF\ibm-ejb-jar-bnd.xmi" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF\ejb-jar.xml" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      echo Ifix_IC52868: SIV config backup complete. >> "%WVS_ROOT%\log\IC52868.log"
      @rem ----------------------------------------------------------------------------

      echo Ifix_IC52868: Updating collector
      echo Ifix_IC52868: Updating collector >> "%WVS_ROOT%\log\IC52868.log"
      call "%WAS_HOME%\java\bin\jar" uvf "%WVS_ROOT%\lib\collector.jar" com >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\lib\collector.jar" "%WAS_HOME%\lib" >> "%WVS_ROOT%\log\IC52868.log"
	  
      copy /y "%~dp0Ifix_IC52868.bat" "%WVS_ROOT%\ifix\."  >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%~dp0stopVoiceServer.jacl" "%WVS_ROOT%\ifix\IC52868\." >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ear\wvsapp.ear" "%WVS_ROOT%\ifix\IC52868\wvsapp.ear.bak" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ViaVoice\bin\ibmgram.dll" "%WVS_ROOT%\ifix\IC52868\ibmgram.dll.bak" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\package\installEar.jacl" "%WVS_ROOT%\ifix\IC52868\installEar.jacl.bak" >> "%WVS_ROOT%\log\IC52868.log"
      
      copy /y "%~dp0wvsapp.ear" "%WVS_ROOT%\ear\."             >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%~dp0ibmgram.dll" "%WVS_ROOT%\ViaVoice\bin\."   >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%~dp0installEar.jacl" "%WVS_ROOT%\package\."    >> "%WVS_ROOT%\log\IC52868.log"

      echo Ifix_IC52868: Starting WebSphere Application Server 
      echo Ifix_IC52868: Starting WebSphere Application Server >> "%WVS_ROOT%\log\IC52868.log"
      call "%WAS_HOME%\bin\startServer.bat" server1 -quiet     >> "%WVS_ROOT%\log\IC52868.log"
      
      if ERRORLEVEL 0  ( 
         echo Ifix_IC52868: WebSphere Application Server Successfully started. 
         echo Ifix_IC52868: WebSphere Application Server Successfully started.  >> "%WVS_ROOT%\log\IC52868.log"
      ) else (
         echo.
         echo Ifix_IC52868: WebSphere Application Server Failed to start Successfully. Exiting ifix installation.   
         echo Ifix_IC52868: WebSphere Application Server Failed to start Successfully. Exiting ifix installation.  >> "%WVS_ROOT%\log\IC52868.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"
         goto:EOF
      )

      echo Ifix_IC52868: Stopping  WebSphere Voice Server
      echo Ifix_IC52868: Stopping  WebSphere Voice Server  >> "%WVS_ROOT%\log\IC52868.log"
      call "%WAS_HOME%\bin\wsadmin.bat" -f "%~dp0stopVoiceServer.jacl"  %WAS_NODE% >> "%WVS_ROOT%\log\IC52868.log"

                           
      if ERRORLEVEL 0  ( 
         echo Ifix_IC52868: Voice Server Successfully stopped. 
         echo Ifix_IC52868: Voice Server Successfully stopped.  >> "%WVS_ROOT%\log\IC52868.log"
      ) else (
         echo.
         echo Ifix_IC52868: Voice Server encountered a failure during stopping. Exiting ifix installation. 
         echo Ifix_IC52868: Voice Server encountered a failure during stopping. Exiting ifix installation.  >> "%WVS_ROOT%\log\IC52868.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"
         goto:EOF
      )
      
      echo Ifix_IC52868: Updating WebSphere Voice Server J2EE Application 
      echo Ifix_IC52868: Updating WebSphere Voice Server J2EE Application     >> "%WVS_ROOT%\log\IC52868.log"
      cd /D "%WVS_ROOT%" >> "%WVS_ROOT%\log\IC52868.log"
      
      call "%WAS_HOME%\bin\wsadmin.bat" -f "%WVS_ROOT%/package/installEar.jacl" "./ear" wvsapp  "WVS5.1-%WAS_NODE%" "%WAS_NODE%" >> "%WVS_ROOT%\log\IC52868.log"
      echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"

      if ERRORLEVEL 0  ( 
         echo.
         echo.
         echo Ifix_IC52868: Ifix is now applied, please reboot the system 
         echo Ifix_IC52868: Ifix is now applied, please reboot the system  >> "%WVS_ROOT%\log\IC52868.log"
      ) else (
         echo.
         echo.
         echo Ifix_IC52868: Ifix encountered a failure during update of the WVS Application, please uninstall the ifix.  
         echo Ifix_IC52868: Ifix encountered a failure during update of the WVS Application, please uninstall the ifix.  >> "%WVS_ROOT%\log\IC52868.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"
         goto:EOF
      )
      
      @rem Restore SIV config files ---------------------------------------------------
      echo Ifix_IC52868: Restoring SIV config files... >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\ibm-web-bnd.xmi" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\web.xml" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\ibm-ejb-jar-bnd.xmi" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\ejb-jar.xml" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\IC52868.log"

      rmdir "%WVS_ROOT%\ifix\IC52868\confbck" /S /Q >> "%WVS_ROOT%\log\IC52868.log"
      echo Ifix_IC52868: SIV config files restored. >> "%WVS_ROOT%\log\IC52868.log"
      @rem ----------------------------------------------------------------------------
      
      goto:EOF
      
      @rem else
:missing
      echo Ifix_IC52868: Ifix files missing, please be sure this script is in same directory as the binary files
      goto:EOF



:uninstallparm

if NOT "%uninstalloption%" == "true" goto :EOF
@rem # Check that the ifix backup files are found
 echo Ifix_IC52868: Checking for ifix backup files ... 
 echo Ifix_IC52868: Checking for ifix backup files ... >> "%WVS_ROOT%\log\IC52868.log"

   if not exist "%WVS_ROOT%\ifix\IC52868\wvsapp.ear.bak" goto:unmissing 
      echo Ifix_IC52868: Ifix backup files found.. proceeding to un-install ifix 
      echo Ifix_IC52868: Ifix backup files found.. proceeding to un-install ifix >> "%WVS_ROOT%\log\IC52868.log"

      echo Ifix_IC52868: Stopping WebSphere Application Server
      echo Ifix_IC52868: Stopping WebSphere Application Server >> "%WVS_ROOT%\log\IC52868.log"
      call "%WAS_HOME%\bin\stopServer.bat" server1 -quiet >> "%WVS_ROOT%\log\IC52868.log"
      if ERRORLEVEL -10  ( 
         echo Ifix_IC52868: WebSphere Application Server Successfully stopped. 
         echo Ifix_IC52868: WebSphere Application Server Successfully stopped.  >> "%WVS_ROOT%\log\IC52868.log"
      ) else (
         echo.
         echo Ifix_IC52868: WebSphere Application Server Failed to stop Successfully. Exiting ifix installation.   
         echo Ifix_IC52868: WebSphere Application Server Failed to stop Successfully.  Exiting ifix installation. >> "%WVS_ROOT%\log\IC52868.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"
         goto:EOF
      )
      timeout /T 20 /NOBREAK  >>  "%WVS_ROOT%\log\IC52868.log"
      
	  @rem Backup SIV config files ----------------------------------------------------
      echo Ifix_IC52868: Backing up SIV config files... >> "%WVS_ROOT%\log\IC52868.log"
      mkdir "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF\ibm-web-bnd.xmi" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF\web.xml" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF\ibm-ejb-jar-bnd.xmi" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF\ejb-jar.xml" "%WVS_ROOT%\ifix\IC52868\confbck" >> "%WVS_ROOT%\log\IC52868.log"
      echo Ifix_IC52868: SIV config backup complete. >> "%WVS_ROOT%\log\IC52868.log"
      @rem ----------------------------------------------------------------------------
	  
      copy /y "%WVS_ROOT%\ifix\IC52868\wvsapp.ear.bak" "%WVS_ROOT%\ear\wvsapp.ear" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\ibmgram.dll.bak" "%WVS_ROOT%\ViaVoice\bin\ibmgram.dll" >> "%WVS_ROOT%\log\IC52868.log"

      echo Ifix_IC52868: Starting WebSphere Application Server
      call "%WAS_HOME%\bin\startServer.bat" server1 -quiet >> "%WVS_ROOT%\log\IC52868.log"

      if ERRORLEVEL 0  ( 
         echo Ifix_IC52868: WebSphere Application Server Successfully started. 
         echo Ifix_IC52868: WebSphere Application Server Successfully started.  >> "%WVS_ROOT%\log\IC52868.log"
      ) else (
         echo Ifix_IC52868: WebSphere Application Server Failed to start Successfully.   
         echo Ifix_IC52868: WebSphere Application Server Failed to start Successfully.  >> "%WVS_ROOT%\log\IC52868.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"
      )

      echo Ifix_IC52868: Updating WebSphere Voice Server J2EE Application
      echo Ifix_IC52868: Updating WebSphere Voice Server J2EE Application >> "%WVS_ROOT%\log\IC52868.log"

      cd "%WVS_ROOT%"
      call "%WAS_HOME%\bin\wsadmin.bat" -f "%WVS_ROOT%/package/installEar.jacl" "./ear" wvsapp "WVS5.1-%WAS_NODE%" "%WAS_NODE%"  >> "%WVS_ROOT%\log\IC52868.log"

      if ERRORLEVEL 0  ( 
         echo.
         echo.
         echo Ifix_IC52868: Ifix is now uninstalled, please reboot the system 
         echo Ifix_IC52868:  Please remove the %WVS_ROOT%\ifix\IC52868 directory before attempting a subsequent install of this ifix.
         echo Ifix_IC52868: Ifix is now uninstalled, please reboot the system  >> "%WVS_ROOT%\log\IC52868.log"
      ) else (
         echo.
         echo.
         echo Ifix_IC52868: Ifix encountered a failure during update of the WVS Application, please retry uninstalling the ifix.  
         echo Ifix_IC52868: Ifix encountered a failure during update of the WVS Application, please retry uninstalling the ifix.  >> "%WVS_ROOT%\log\IC52868.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\IC52868.log"
      )
	  
      @rem Restore SIV config files ---------------------------------------------------
      echo Ifix_IC52868: Restoring SIV config files... >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\ibm-web-bnd.xmi" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\web.xml" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\ibm-ejb-jar-bnd.xmi" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\IC52868.log"
      copy /y "%WVS_ROOT%\ifix\IC52868\confbck\ejb-jar.xml" "%WAS_HOME%\config\cells\%WAS_CELL%\applications\WVS5.1-%WAS_NODE%.ear\deployments\WVS5.1-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\IC52868.log"

      rmdir "%WVS_ROOT%\ifix\IC52868\confbck" /S /Q >> "%WVS_ROOT%\log\IC52868.log"
      echo Ifix_IC52868: SIV config files restored. >> "%WVS_ROOT%\log\IC52868.log"
      @rem ----------------------------------------------------------------------------
      
      goto :END
     
:unmissing
      echo Ifix_IC52868: Ifix backup files missing, uninstall not performed
 
popd
:END


